kmp求前缀和后缀的最大重复部分

来源:互联网 发布:门诊收费软件 编辑:程序博客网 时间:2024/05/22 01:52
 

hdu 2594 kmp水题 求s1的前缀和s2的后缀重复度的最大值

 1199人阅读 评论(0) 收藏 举报
 分类:

Simpsons’ Hidden Talents

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 1588    Accepted Submission(s): 587


Problem Description
Homer: Marge, I just figured out a way to discover some of the talents we weren’t aware we had.
Marge: Yeah, what is it?
Homer: Take me for example. I want to find out if I have a talent in politics, OK?
Marge: OK.
Homer: So I take some politician’s name, say Clinton, and try to find the length of the longest prefix
in Clinton’s name that is a suffix in my name. That’s how close I am to being a politician like Clinton
Marge: Why on earth choose the longest prefix that is a suffix???
Homer: Well, our talents are deeply hidden within ourselves, Marge.
Marge: So how close are you?
Homer: 0!
Marge: I’m not surprised.
Homer: But you know, you must have some real math talent hidden deep in you.
Marge: How come?
Homer: Riemann and Marjorie gives 3!!!
Marge: Who the heck is Riemann?
Homer: Never mind.
Write a program that, when given strings s1 and s2, finds the longest prefix of s1 that is a suffix of s2.
 

Input
Input consists of two lines. The first line contains s1 and the second line contains s2. You may assume all letters are in lowercase.
 

Output
Output consists of a single line that contains the longest string that is a prefix of s1 and a suffix of s2, followed by the length of that prefix. If the longest such string is the empty string, then the output should be 0.
The lengths of s1 and s2 will be at most 50000.
 

Sample Input
clintonhomerriemannmarjorie
 

Sample Output
0rie 3
 

Source
HDU 2010-05 Programming Contest
 

Recommend
lcy
 
飞机票:http://acm.hdu.edu.cn/showproblem.php?pid=2594
 
题意:  输入 s1 s2  问s1的后缀 以及s2的前缀中 相同的字符最多有多少个  是什么
 
 
思路:  kmp
 
[cpp] view plain copy
  1. #include<stdio.h>  
  2. #include<string.h>  
  3. char s1[51111],s2[51111];  
  4. int next[51111];  
  5. int d1,d2;  
  6. void getnext()  
  7. {  
  8.     int i=1,j=0;  
  9.     next[1]=0;  
  10.     while(i<=d1)  
  11.     {  
  12.         if(j==0||s1[i]==s1[j]) {i++;j++;next[i]=j;}  
  13.         else j=next[j];  
  14.     }  
  15. }  
  16. int kmp()  
  17. {  
  18.     int i,j;  
  19.     i=1;j=1;  
  20.     while(i<=d2)  
  21.     {  
  22.         if(j==0||s2[i]==s1[j]) {i++;j++;}  
  23.         //不用担心这里j会超出其最大长度d2 因为当j==d2+1的时候 就会进入j=next[j]返回前面去了  
  24.         //因为s1[d2+1]是没有值的不会等于对应位置的s2中的值  会返回到前面去  
  25.         else j=next[j];  
  26.     }  
  27.     return j-1;  
  28. }  
  29. int main()  
  30. {  
  31.     int k;  
  32.     while(scanf("%s",s1+1)!=EOF)  
  33.     {  
  34.         scanf("%s",s2+1);  
  35.         d1=strlen(s1+1);  
  36.         d2=strlen(s2+1);//s2做主串  
  37.         getnext();  
  38.         k=kmp();  
  39.         if(k==0) printf("0\n");  
  40.         else  
  41.         printf("%s %d\n",s2+1+d2-k,k);  
  42.     }  
  43.     return 0;  
  44. }  
  45. 下面是另一种做法
  46. 题意:

    给你两个串a,b,求既是a的前缀又是b的后缀的最长子串的长度。

    分析:

    很自然的想到把两个串连接起来,根据KMP的性质求即可

    复制代码
    #include <map>#include <set>#include <list>#include <cmath>#include <queue>#include <stack>#include <cstdio>#include <vector>#include <string>#include <cctype>#include <complex>#include <cassert>#include <utility>#include <cstring>#include <cstdlib>#include <iostream>#include <algorithm>using namespace std;typedef pair<int,int> PII;typedef long long ll;#define lson l,m,rt<<1#define pi acos(-1.0)#define rson m+1,r,rt<<11#define All 1,N,1#define N 50010#define read freopen("in.txt", "r", stdin)const ll  INFll = 0x3f3f3f3f3f3f3f3fLL;const int INF= 0x7ffffff;const int mod =  1000000007;char a[N*2],b[N];int f[N*2];void getnext(int n){    int i=0,j=-1;    f[0]=-1;    while(i<n){        if(j==-1||a[i]==a[j]){            i++;            j++;            f[i]=j;        }        else            j=f[j];    }}void solve(){    int len1=strlen(a);    int len2=strlen(b);    strcat(a,b);     int tmp=len1+len2;    getnext(tmp);    //必须是两串的子串    while(f[tmp]>len1)tmp=f[tmp];    while(f[tmp]>len2)tmp=f[tmp];    if(f[tmp]==0)        printf("0\n");    else{        for(int i=0;i<f[tmp];++i)            printf("%c",a[i]);        printf(" %d\n",f[tmp]);    }}int main(){    while(~scanf("%s%s",a,b)){        solve();    }return 0;}
    复制代码

0 0
原创粉丝点击